<template>
    <div class="container mt-4">
        <div class="row">
            <div class="col-md-5">
                <div class="card shadow">
                    <div class="card-header bg-warning p-0">
                        <img src="https://paradepets.com/.image/t_share/MTkxMzY1Nzg4NjczNTgyNjkw/most-popular-cat-breeds.png"
                            class="card-img-top" alt="img">
                    </div>
                    <div class="card-body">
                        <p class="card-text">
                            &copy;เทคโนโลยีสารสนเทศ 2024.
                        </p>
                    </div>
                </div>
            </div>

            <div class="col-md-6">
                <div class="card shadow">
                    <div class="card-header bg-primary">
                        <h5 class="text-white">
                            ระบบลงทะเบียนผู้ใช้งาน
                        </h5>
                    </div>
                    <div class="card-body">
                        <p class="card-text text-success">
                            <form @submit.prevent>
                                <div class="mb-2">
                                    <label for="" class="form-label">ชื่อ</label>
                                    <input type="text" v-model="userForm.fname" class="form-control" placeholder="ชื่อผู้สมัคร" required>
                                    <span class="text-danger" v-for="error in v$.fname.$errors" :key="error.$uid" v-if="true">
                                        <strong>{{ error.$property }} {{ error.$message }}</strong>
                                    </span>
                                </div>
                                <div class="mb-2">
                                    <label for="" class="form-label">นามสกุล</label>
                                    <input type="text" v-model="userForm.lname" class="form-control" placeholder="นามสกุลผู้สมัคร" required>
                                    <span class="text-danger" v-for="error in v$.lname.$errors" :key="error.$uid" v-if="true">
                                        <strong>{{ error.$property }} {{ error.$message }}</strong>
                                    </span>
                                </div>

                                <div class="mb-2">
                                    <label for="" class="form-label">อีเมลล์</label>
                                    <input type="email" v-model="userForm.email" class="form-control" placeholder="อีเมลล์" required>
                                    <span class="text-danger" v-for="error in v$.email.$errors" :key="error.$uid" v-if="true">
                                        <strong>{{ error.$property }} {{ error.$message }}</strong>
                                    </span>
                                </div>

                                <div class="mb-2">
                                    <label for="" class="form-label">รหัสผ่าน</label>
                                    <input type="password" v-model="userForm.password" class="form-control" placeholder="รหัสผ่าน" required>
                                    <span class="text-danger" v-for="error in v$.password.$errors" :key="error.$uid" v-if="true">
                                        <strong>{{ error.$property }} {{ error.$message }}</strong>
                                    </span>
                                </div>
                                <div class="mb-2">
                                    <label for="" class="form-label">ยืนยันรหัสผ่าน</label>
                                    <input type="password" v-model="userForm.passwordConfirm" class="form-control" placeholder="ยืนยันรหัสผ่าน" required>
                                    <span class="text-danger" v-for="error in v$.passwordConfirm.$errors" :key="error.$uid" v-if="true">
                                        <strong>{{ error.$property }} {{ error.$message }}</strong>
                                    </span>
                                </div>
                                <div class="mb-2">
                                    <label for="" class="form-label">เบอร์โทรศัพท์</label>
                                    <input type="text" v-model="userForm.phone" class="form-control" placeholder="เบอร์โทรศัพท์" required>
                                    <span class="text-danger" v-for="error in v$.phone.$errors" :key="error.$uid" v-if="true">
                                        <strong>{{ error.$property }} {{ error.$message }}</strong>
                                    </span>
                                </div>

                                <div class="mb-2">
                                    <label for="" class="form-label m-2">ที่อยู่</label>
                                    <textarea v-model="userForm.address" cols="50" rows="2"></textarea>
                                </div>
                                    <span class="text-danger" v-for="error in v$.address.$errors" :key="error.$uid" v-if="true">
                                        <strong>{{ error.$property }} {{ error.$message }}</strong>
                                    </span>

                                <div class="mb-2">
                                    <p type="submit" class="btn btn-primary btn-sm shadow d-block" @click="notify">
                                        สมัครสมาชิก
                                    </p>
                                </div>
                            </form>
                        </p>
                        <div class="mb-1">
                            <router-link :to="{name:'signin'}" class="text-decoration-none font-weight-bolder">
                                <p type="submit" class="btn shadow d-block">
                                    มีบัญชีอยู่แล้ว?
                                </p>
                            </router-link>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</template>

<script setup>
import axios, { Axios } from 'axios'
import { computed, reactive } from 'vue'
import { toast } from 'vue3-toastify'
import { useVuelidate } from '@vuelidate/core'
import { email,required,sameAs, minLength } from '@vuelidate/validators'
import router from '@/router'

const state = reactive({
    name: 'signin'
})

const notify = async () => {
    const result = await v$.value.$validate()
    if(result){
        toast.success("Submit successful", {
            autoClose: 1000,
            position:toast.POSITION.TOP_CENTER
        });
        const result = await axios.post('http://localhost:8000/users',{
            fname: userForm.fname,
            lname: userForm.lname,
            email: userForm.email,
            password: userForm.password,
            passwordConfirm: userForm.passwordConfirm,
            phone: userForm.phone,
            address: userForm.address
        })
        if(result.status==201){
            console.log('Success')
            localStorage.setItem('user-info',JSON.stringify(result.data))
            console.log(result.data)
            console.log(JSON.stringify(result.data))
            router.push(state.name)
        }
        else{
            console.log('Error')
        }
    }
    else{
        toast.error("Error",{
            autoClose: 1000,
            position:toast.POSITION.TOP_CENTER
            
        });
    }
}

const userForm = reactive({
    fname: "",
    lname: "",
    email: "",
    password: "",
    passwordConfirm: "",
    phone: "",
    address: "",
})
const rules = computed (() => {
    return{
        fname: { required },
        lname: { required },
        email: { required, email },
        password: { required, minLength: minLength(4) },
        passwordConfirm: { required, sameAs: sameAs(userForm.password) },
        phone: { required },
        address: { required },
    }
})




const v$ = useVuelidate(rules, userForm)

</script>

<style>
@import url('https://fonts.googleapis.com/css2?family=Sarabun&display=swap');

.form-label {
    font-family: 'Sarabun', sans-serif;
}

.btn {
    font-family: 'Sarabun', sans-serif;
}
</style>
